package the.bytecode.club.bytecodeviewer.malwarescanner;

import org.objectweb.asm.tree.ClassNode;

import java.util.ArrayList;
import java.util.HashSet;

/**
 * A new malware scan object is created any time the MalicousCodeScanner plugin is ran
 *
 * This contains all of the details for the scan, including what should be scanned,
 * and what was detected during the scan.
 *
 * @author Konloch
 * @since 6/27/2021
 */
public class MalwareScan
{
	public final ArrayList<ClassNode> classNodeList;
	public final StringBuilder sb;
	public final HashSet<String> scanOptions;
	
	public MalwareScan(ArrayList<ClassNode> classNodeList, StringBuilder sb, HashSet<String> scanOptions)
	{
		this.classNodeList = classNodeList;
		this.sb = sb;
		this.scanOptions = scanOptions;
	}
}
